# PLDroidShortVideo Release Notes for 3.4.0

### 简介

PLDroidShortVideo 是七牛推出的一款适用于 Android 平台的短视频 SDK，提供了包括美颜、滤镜、水印、断点录制、分段回删、视频编辑、混音特效、本地/云端存储在内的多种功能，支持高度定制以及二次开发。

### 版本

* 发布 pldroid-shortvideo-3.4.0.jar
* 更新上传库依赖版本到 v8.4.3

### 功能

* PLMediaFile 增加方法支持判断视频编码格式是否为 H.265
* PLDisplayMode 增加 KEEP 模式
* 视频录制支持无麦克风权限
* 优化混音切换逻辑
* 编辑模块水印设置支持层级设置
* 优化软编码的内存使用情况
* 视频录制的同时支持旋转摄像头
* 支持单个 GIF 转视频操作
* 转码、编辑、图片转视频模块支持软编码
* 水印增加角度设置
* PLMicrophoneSetting 增加判断手机是否支持双声道的方法
* 优化编码处理方式
* 优化预览视图，使其即时相应外部视图宽高变化
* 优化抽帧操作的耗时
* 优化 SDK 所需权限，极大限度降低所需的权限
* 支持自动曝光

### 缺陷

* 修复极慢速录制预览可能卡顿的问题
* 修复个别机型转码时码率达不到预期的问题
* 修复转码后的视频在存储到云端后使用在线播放时出现大量 206 请求的问题
* 修复录屏偶现无视频帧的问题
* 修复编辑模块在一帧添加大量 GIF 时出现部分 GIF 丢失的问题
* 修复偶现的 ANR 问题
* 修复在部分三星手机转码进度卡住的问题
* 修复在部分机型上图片转视频出现色差的问题
* 修复转码部分视频进度会卡住的问题
* 修复部分机型切换摄像头时出现画面缩放的一帧的问题
* 修复编码因异常停止后此后不能再启动的问题
* 修复转码默认的画面拉伸模式的问题
* 修复连续转码后续修改参数无效的问题
* 修复偶现的 OpenGL 环境创建崩溃的问题
* 修复频繁进行添加删除 GIF 操作导致结果异常的问题
* 修复部分机型录制帧率不达预期的问题
* 修复部分机型使用软编出现卡住的问题
* 修复部分机型后置转前置出现的预览异常问题
* 修复软编码视频可能出现的进度卡住问题

### 注意事项

* 从 v3.1.0 版本开始，需要在 Application 中初始化 sdk：

```java
PLShortVideoEnv.init(getApplicationContext());
```

* 七牛短视频 SDK 自 v3.0.0 版本起, 划分为精简版、基础版、进阶版、专业版。不同版本 SDK 可以使用的功能点数量有差别，请按照购买的 License 版本使用对应的短视频 SDK 版本。
* 上传 SDK 的依赖需要更新到如下版本：

```java
compile 'com.qiniu:qiniu-android-sdk:8.4.3'
```
